'
' incLean2 v1.31, by Borje Hagsten January, 2003
'
' incLean is a utility for PB/DLL, enabling exact trimming of
' included API files. Code is based on PBcodec project parser,
' with additional include file parser.
'
' inClean scans your main code file, looks for all include files,
' scans all code and extract only those equName, TYPE structures
' declares, subs and functions needed for the project. Output is
' written to WINCLEAN.INC, which is the only file you need to include
' after inClean has been run.
'

#COMPILE DLL
#RESOURCE "INCLEAN2.PBR"   'resource file, containing right-hand cursor, etc..
#INCLUDE  "IncLean2.inc"
'#INCLUDE  "WIN32API.INC"  'Basic Win API definitions
'------------------------------------------------------------------------------
%IDM_COPY     = %WM_USER + 1033  ' Copy selection
%IDM_SELALL   = %WM_USER + 1038  ' Select all
'------------------------------------------------------------------------------
GLOBAL ic AS LONG, cEqu AS LONG, cStruct AS LONG, cFunc AS LONG, cSub AS LONG, cFunc2 AS LONG, _
       cSub2 AS LONG, gTotLines AS LONG, gIncLine AS LONG, gUseMacros AS LONG, ghDev AS LONG

GLOBAL WinApiDone AS LONG
GLOBAL inclCommCtrl AS LONG, inclComDlg32 AS LONG, inclRichEdit AS LONG, inclMdi32 AS LONG
GLOBAL tTot AS SINGLE, tRead AS SINGLE, tScan AS SINGLE, tTotAll AS SINGLE

GLOBAL FilePathStr AS STRING, FileNameStr AS STRING
GLOBAL Win32ApiFile AS STRING, MainCodeFile AS STRING, OutPutFile AS STRING, CommCtrlFile AS STRING
GLOBAL sTemp AS STRING, sWork AS STRING, LineStr AS STRING, sOldInclPath AS STRING

GLOBAL pbWords()    AS STRING
GLOBAL pbStart()    AS LONG
GLOBAL pbCount()    AS LONG

GLOBAL equName()    AS STRING
GLOBAL equFull()    AS STRING
GLOBAL equResName() AS STRING
GLOBAL equResFull() AS STRING
GLOBAL cEquRes      AS LONG
GLOBAL equStart()   AS LONG
GLOBAL equCount()   AS LONG

GLOBAL structName()    AS STRING
GLOBAL structFull()    AS STRING
GLOBAL structResName() AS STRING
GLOBAL structResFull() AS STRING
GLOBAL cStructRes      AS LONG
GLOBAL StructStart()   AS LONG
GLOBAL StructCount()   AS LONG

GLOBAL funcName()      AS STRING
GLOBAL funcFull()      AS STRING
GLOBAL funcResName()   AS STRING
GLOBAL funcResFull()   AS STRING
GLOBAL cFuncRes        AS LONG
GLOBAL FuncStart()     AS LONG
GLOBAL FuncCount()     AS LONG

GLOBAL subName()       AS STRING
GLOBAL subFull()       AS STRING
GLOBAL subResName()    AS STRING
GLOBAL subResFull()    AS STRING
GLOBAL cSubRes         AS LONG
GLOBAL SubStart()      AS LONG
GLOBAL SubCount()      AS LONG

GLOBAL ifuncName()     AS STRING
GLOBAL ifuncFull()     AS STRING
GLOBAL ifuncResName()  AS STRING
GLOBAL ifuncResFull()  AS STRING
GLOBAL icFuncRes       AS LONG
GLOBAL iFuncStart()    AS LONG
GLOBAL iFuncCount()    AS LONG

GLOBAL isubName()      AS STRING
GLOBAL isubFull()      AS STRING
GLOBAL isubResName()   AS STRING
GLOBAL isubResFull()   AS STRING
GLOBAL icSubRes        AS LONG
GLOBAL iSubStart()     AS LONG
GLOBAL iSubCount()     AS LONG

'GLOBAL inFile()       AS STRING
GLOBAL Files()        AS STRING
GLOBAL sIncDir()      AS STRING
'------------------------------------------------------------------------------
DECLARE FUNCTION DoGetIncFiles(BYVAL TheFile AS STRING) AS LONG
DECLARE FUNCTION DoInitProcess(BYVAL hParent AS LONG, BYVAL fName AS STRING) AS LONG
DECLARE FUNCTION DoProcess(BYVAL TheFile AS STRING) AS LONG
DECLARE FUNCTION doFileExist(BYVAL sfName AS STRING) AS LONG
DECLARE FUNCTION GetRoutineDeclare(BYVAL txt AS STRING) AS STRING
DECLARE FUNCTION IsFileMain(BYVAL fName AS STRING) AS LONG
DECLARE FUNCTION LoadPBdata2(dArray() AS STRING) AS LONG
DECLARE FUNCTION ReadIncFile(BYVAL incFile AS STRING, _
                             BYVAL whatRun AS LONG, BYVAL lastRun AS LONG) AS LONG
DECLARE FUNCTION ResolveRelativePath(BYVAL BasePathStr AS STRING, BYVAL sWork AS STRING) AS STRING
DECLARE FUNCTION doUCASER(BYVAL st AS STRING) AS STRING

DECLARE SUB DoSaveResults (BYVAL theFile AS STRING, BYVAL Run0 AS LONG, BYVAL realSave AS LONG)
DECLARE SUB doUCASE(a$)
DECLARE SUB IndexArray(aName() AS STRING, aFull() AS STRING, aStart() AS LONG, aCount() AS LONG)
DECLARE SUB IndexArray2(aName() AS STRING, aFull() AS STRING, _
                        aStart() AS LONG, aCount() AS LONG, BYVAL special AS LONG)
DECLARE SUB IndexEquates2(aName() AS STRING, aFull() AS STRING, aStart() AS LONG, aCount() AS LONG)
DECLARE SUB NewEvents
DECLARE SUB ResolveIncPath(BYVAL tmpIncDir AS STRING)

'
' DLL call..
'
FUNCTION doIncLean ALIAS "doIncLean" (BYVAL hParent AS DWORD, BYVAL sMainFile AS STRING, _
                    BYVAL ResultIncFile AS STRING, BYVAL sInclPath AS STRING, _
                    OPT BYVAL CommCtrlInc AS LONG, OPT BYVAL ComDlg32Inc AS LONG, _
                    OPT BYVAL RichEditInc AS LONG, OPT BYVAL MDI32Inc AS LONG) EXPORT AS LONG

  IF LEN(sMainFile)     = 0 THEN FUNCTION = -1 : EXIT FUNCTION ' no Main code file name
  IF LEN(ResultIncFile) = 0 THEN FUNCTION = -2 : EXIT FUNCTION ' no output file name
  IF LEN(sInclPath)     = 0 THEN FUNCTION = -3 : EXIT FUNCTION ' no PB includes path

  IF sInclPath <> sOldInclPath THEN
     sOldInclPath = sInclPath
     IF UBOUND(sIncDir) > -1 THEN ERASE sIncDir
     ResolveIncPath sInclPath
  END IF
  IF UBOUND(sIncDir) = -1 THEN FUNCTION = -4 : EXIT FUNCTION ' include file failure

  IF CommCtrlInc <> inclCommCtrl THEN WinApiDone = 0
  IF ComDlg32Inc <> inclComDlg32 THEN WinApiDone = 0
  IF RichEditInc <> inclRichEdit THEN WinApiDone = 0
  IF MDI32Inc    <> inclMdi32    THEN WinApiDone = 0

  IF WinApiDone THEN
     IF UBOUND(sIncDir) > -1 AND LEN(Win32ApiFile) THEN
        IF UCASE$(sIncDir(0)) + "WIN32API.INC" <> UCASE$(Win32ApiFile) THEN
           Win32ApiFile = sIncDir(0) + "WIN32API.INC"
           WinApiDone = 0
        END IF
     END IF
  END IF

  MainCodeFile = TRIM$(sMainFile, ANY " " + $DQ)
  OutPutFile   = TRIM$(ResultIncFile, ANY " " + $DQ)
  inclCommCtrl = CommCtrlInc
  inclComDlg32 = ComDlg32Inc
  inclRichEdit = RichEditInc
  inclMdi32    = MDI32Inc

  IF UBOUND(pbWords) = -1 THEN
     LoadPBdata2 pbWords()
  END IF

  tTotAll = TIMER
  REDIM Files(1)  ' Reset Array

  FUNCTION = DoInitProcess(hParent, MainCodeFile)

END FUNCTION

'
' DLL main..
'
FUNCTION LIBMAIN (BYVAL hInstance   AS LONG, _
                  BYVAL fwdReason   AS LONG, _
                  BYVAL lpvReserved AS LONG) AS LONG
    SELECT CASE fwdReason
        CASE %DLL_PROCESS_ATTACH : FUNCTION = 1
        CASE %DLL_PROCESS_DETACH : FUNCTION = 1
        CASE %DLL_THREAD_ATTACH  : FUNCTION = 1
        CASE %DLL_THREAD_DETACH  : FUNCTION = 1
    END SELECT
END FUNCTION

'
' Get all included files into array
'
FUNCTION DoGetIncFiles(BYVAL TheFile AS STRING) AS LONG
  LOCAL ci AS LONG, ii AS LONG, p AS LONG, fc AS LONG, isDup AS LONG, Letter AS BYTE PTR
  REDIM tmpFiles(0) AS STRING

'  IF UCASE$(MID$(TheFile, INSTR(-1, TheFile, "\") + 1)) = "WIN32API.INC" THEN EXIT FUNCTION
  IF doFileExist(TheFile) = 0 THEN EXIT FUNCTION

  LOCAL hFile AS LONG, nSize AS LONG, rSize AS LONG
  hFile = CreateFile(BYVAL STRPTR(TheFile), %GENERIC_READ, %FILE_SHARE_READ, BYVAL 0&, %OPEN_EXISTING, 0, 0)
  IF hFile = %INVALID_HANDLE_VALUE THEN EXIT FUNCTION
  nSize    = GetFileSize(hFile, 0)
  IF nSize > 0 THEN
     sTemp = SPACE$(nSize)
     SetFilePointer hFile, 0, 0, %FILE_BEGIN
     ReadFile hFile, BYVAL STRPTR(sTemp), nSize, rSize, BYVAL %NULL
  END IF
  CloseHandle hFile
  IF rSize <> nSize THEN EXIT FUNCTION

'  OPEN TheFile FOR BINARY AS #1 LEN = 16383
'     IF ERR THEN
'        RESET : ERRCLEAR : EXIT FUNCTION
'     END IF
'     GET$ #1, LOF(1), sTemp
'  CLOSE #1
'  IF LEN(sTemp) < 2 THEN EXIT FUNCTION

  REPLACE $TAB WITH SPACE$(4) IN sTemp   'ensure there are no TAB$
  p = 1
  Letter = STRPTR(sTemp)

  FOR ci = 1 TO LEN(sTemp)
     IF @Letter = 13 THEN
        p = ci - p
        IF p > 8 AND PEEK(Letter - p) <> 39  THEN 'if more than a line feed and not remmed out
           IF PEEK(Letter - p) <> 32 THEN                      'if not leading space
              LineStr = doUCASER(PEEK$(Letter - p, p))
           ELSE
              LineStr = doUCASER(LTRIM$(PEEK$(Letter - p, p)))
           END IF

           IF (ASC(LineStr) = 35 OR ASC(LineStr) = 36) AND _  '$#
           MID$(LineStr, 2, 8) = "INCLUDE " THEN       'can be several INCLUDE statements in file, anywhere in code..
              sWork = TRIM$(PARSE$(LineStr, CHR$(34), 2))     'get filename

              IF INSTR(sWork, "WIN32API.INC") OR _
                 (inclCommCtrl AND INSTR(sWork, "COMMCTRL.INC")) OR _
                    (inclComDlg32 AND INSTR(sWork, "COMDLG32.INC")) OR _
                       (inclRichEdit AND INSTR(sWork, "RICHEDIT.INC")) OR _
                          (inclMdi32    AND INSTR(sWork, "MDI32.INC")) THEN
                  GOTO mylabel 'tried ITERATE FOR here, but it sometimes failed, so..
              END IF

              IF INSTR(sWork, ANY "\/") THEN _
                 sWork = ResolveRelativePath(FilePathStr, sWork)

              IF INSTR(-1, sWork, ".") = 0 THEN          'if no file extension is given,
                 sWork = sWork + ".BAS"                  'compiler assumes .BAS file
              END IF

              'if no path is given, compiler will first look in include dir, so we better start there
              IF INSTR(sWork, "\") = 0 THEN                          'if no path given
                 FOR ii = 0 TO UBOUND(sIncDir)                       'loop through the ones we have
                    IF doFileExist(sIncDir(ii) + sWork) THEN         'if file exists
                       sWork = sIncDir(ii) + sWork                   'use it
                    END IF
                 NEXT
              END IF

              IF LEN(FilePathStr) AND doFileExist(FilePathStr + sWork) THEN 'try with current file's path
                 sWork = FilePathStr + sWork                      'if ok, use it
              END IF

              IF doFileExist(sWork) THEN                  'safety check - if we can find what we got..
                 ARRAY SCAN tmpFiles(0), COLLATE UCASE, = UCASE$(sWork), TO isDup 'one of each is enough..
                 IF isDup = 0 THEN
                    ARRAY SCAN Files(0), COLLATE UCASE, = UCASE$(sWork), TO isDup 'must check all files too..
                    IF isDup = 0 THEN
                       tmpFiles(fc) = sWork                   'store path + name in temporary array
                       INCR fc : REDIM PRESERVE tmpFiles(fc)  'incr counter and redim temporary array
                    END IF
                 END IF
              END IF

           ELSEIF ASC(LineStr) = 37 AND MID$(LineStr, 2, 10) = "USEMACROS " THEN ' check %USEMACROS value
              sWork = TRIM$(PARSE$(LineStr, "=", 2))     'get value
              IF VAL(LEFT$(sWork, 1)) <> 0 THEN gUseMacros = 1
           END IF
        END IF

        mylabel:
        INCR Letter : INCR ci : p = ci + 1              'jump past LF and store position
     END IF
     INCR Letter
  NEXT ci

  IF fc THEN
     fc = UBOUND(tmpFiles)
     p  = UBOUND(Files)
     REDIM PRESERVE Files(p + fc)
     'REDIM PRESERVE inFile(p + fc)

     FOR ci = 0 TO fc
        Files(p + ci)  = tmpFiles(ci)
        'inFile(p + ci) = MID$(TheFile, INSTR(-1, TheFile, "\") + 1)
     NEXT
     FOR ci = 0 TO fc
        SELECT CASE UCASE$(MID$(tmpFiles(ci), INSTR(-1, tmpFiles(ci), "\") + 1)) 'ignore recursing these
           CASE "WIN32API.INC", "COMDLG32.INC", "COMMCTRL.INC", "PBFORMS.INC", "COMBO32.INC", _
                "DDT.INC", "MDI32.INC", "LISTVIEW.INC", "TRVIEW32.INC", "RICHEDIT.INC", _
                "EDIT32.INC", "BUTTON32.INC", "MMSYSTEM.INC", "WSOCK32.INC", "SECEXT.INC", _
                "WS2_32.INC", "IPHLPAPI.INC", "WINWLX.INC", "INITCTRL.INC", "LMWKSTA.INC", _
                "SHLWAPI.INC", "RAS32.INC", "CPL.INC", _
                "STATIC32.INC", "DPMI.INC", "LZEXPAND.INC", "TOOLHLP.INC", "VBAPI.INC", _
                "PRSHT.INC", "CTL3D.INC", "VER.INC", "WINAPI.INC", "WINSOCK.INC", "COMMDLG.INC"

           CASE ELSE
              CALL DoGetIncFiles(tmpFiles(ci)) 'recursive call to get eventual includes in includes
         END SELECT
     NEXT
  END IF

END FUNCTION

'************************************************************************
' Initiate and run entire process
'************************************************************************
FUNCTION DoInitProcess(BYVAL hDlg AS LONG, BYVAL fName AS STRING) AS LONG
  LOCAL ci AS LONG, ufName AS STRING
  LOCAL w AS LONG, c1 AS LONG, c2 AS LONG, c3 AS LONG, c4 AS LONG

  IF doFileExist(OutPutFile) THEN                'if Output file already exists
     OPEN OutPutFile FOR BINARY AS #1 LEN = 16383 'open it
        IF ERR THEN                               'if it failed
           RESET : ERRCLEAR                       'reset, clear error and exit
'           MessageBox hDlg, _
'              "Could not check already existing file with same name as" + $CRLF + _
'              "the output file. Please make sure no other program holds" + $CRLF + _
'              "this file open and try again!", _
'              "Output file error!", %MB_OK OR %MB_ICONEXCLAMATION
           FUNCTION = -5 : EXIT FUNCTION
        END IF
        GET$ #1, LOF(1), ufName                   'else load contents into ufName
     CLOSE #1                                     'close file
     IF LEN(ufName) THEN                          'if any contents
        IF LEFT$(ufName, 25) <> "' Main source code file: " THEN 'look for initial inClean text
'           MessageBox hDlg, _
'              "A file with same name as the output file, not created by inClean" + $CRLF + _
'              "already exists. To avoid overwriting this file, please change the" + $CRLF + _
'              "output file name.", _
'              "Output file name message!", %MB_OK OR %MB_ICONEXCLAMATION
           ufName = ""
           FUNCTION = -6 : EXIT FUNCTION
        END IF
     END IF
  END IF

  IF doFileExist(fName) = 0 THEN
'     MessageBox hDlg, _
'        "Could not find given Main source code file!" + $CRLF + _
'        "Please check Main file's name and try again.", _
'        "Main file error!", %MB_OK OR %MB_ICONEXCLAMATION
        FUNCTION = -7 : EXIT FUNCTION
  END IF

'  NewEvents

  FilePathStr = LEFT$(fName, INSTR(-1, fName, "\"))
  FileNameStr = MID$(fName, INSTR(-1, fName, "\") + 1)
'  NewEvents

  IF Files(0) = "" THEN Files(0) = fName
  CHDRIVE LEFT$(FilePathStr, 2)
  CHDIR FilePathStr

  DoGetIncFiles fName
  Win32ApiFile = sIncDir(0) + "Win32api.inc"

  LOCAL isMain AS LONG
  FOR ci = 0 TO UBOUND(Files) - 1
     IF UCASE$(RIGHT$(Files(ci), 12)) <> "WIN32API.INC" OR _
           UCASE$(RIGHT$(Files(ci), 12)) <> "COMMCTRL.INC" OR _
              UCASE$(RIGHT$(Files(ci), 12)) <> "COMDLG32.INC" THEN
        isMain = IsFileMain(Files(ci)) 'if a #COMPILE statement exists (main source file)
        IF isMain = 1 THEN EXIT FOR
     END IF
  NEXT
  IF isMain < 1 THEN
'     MessageBox hDlg, _
'        "Project MUST include a main PB source file with a COMPILE statement!" + CHR$(0), _
'        "Main file error!" + CHR$(0), %MB_OK OR %MB_ICONEXCLAMATION
     FUNCTION = -8 : EXIT FUNCTION
  END IF

  '------------------------------------------------------------
  IF WinApiDone = 0 THEN
     tRead = TIMER
     w = 0

     IF inclCommCtrl THEN c1 = 1 : w = 1
     IF inclComDlg32 THEN c2 = 2 : w = 2
     IF inclRichEdit THEN c3 = 3 : w = 3
     IF inclMdi32    THEN c4 = 4 : w = 4

     ReadIncFile Win32ApiFile, 0, w

     IF c1 THEN
        CommCtrlFile = LEFT$(Win32ApiFile, INSTR(-1, Win32ApiFile, "\")) + "COMMCTRL.INC"
        ReadIncFile CommCtrlFile, c1, w
     END IF

     IF c2 THEN
        CommCtrlFile = LEFT$(Win32ApiFile, INSTR(-1, Win32ApiFile, "\")) + "COMDLG32.INC"
        ReadIncFile CommCtrlFile, c2, w
     END IF
     
     IF c3 THEN
        CommCtrlFile = LEFT$(Win32ApiFile, INSTR(-1, Win32ApiFile, "\")) + "RICHEDIT.INC"
        ReadIncFile CommCtrlFile, c3, w
     END IF

     IF c4 THEN
        CommCtrlFile = LEFT$(Win32ApiFile, INSTR(-1, Win32ApiFile, "\")) + "MDI32.INC"
        ReadIncFile CommCtrlFile, c4, w
     END IF

     WinApiDone = 1
     tRead = TIMER - tRead
  END IF
  '------------------------------------------------------------

  REDIM equResName(0)    : REDIM equResFull(0)    : cEquRes = 0
  REDIM structResName(0) : REDIM structResFull(0) : cStructRes = 0
  REDIM funcResName(0)   : REDIM funcResFull(0)   : cFuncRes = 0
  REDIM subResName(0)    : REDIM subResFull(0)    : cSubRes = 0
  REDIM ifuncResName(0)  : REDIM ifuncResFull(0)  : icFuncRes = 0
  REDIM isubResName(0)   : REDIM isubResFull(0)   : icSubRes = 0
  gTotLines = 0
  tScan = TIMER

  FOR ci = 0 TO UBOUND(Files) - 1
'     NewEvents
     ufName = UCASE$(MID$(Files(ci), INSTR(-1, Files(ci), "\") + 1))
     IF (inclCommCtrl = 0 AND ufName = "COMMCTRL.INC") OR _
           (inclComDlg32 = 0 AND ufName = "COMDLG32.INC") OR _
              (inclRichEdit = 0 AND ufName = "RICHEDIT.INC") OR _
                 (inclMdi32    = 0 AND ufName = "MDI32.INC") THEN
'        NewEvents
        DoProcess Files(ci)
     ELSE
        SELECT CASE ufName       
           CASE "WIN32API.INC" 'ignore this one
              Win32ApiFile = Files(ci)
           CASE "COMMCTRL.INC", "COMDLG32.INC", "RICHEDIT.INC", "MDI32.INC" 'ignore these here
              CommCtrlFile = Files(ci)
           CASE ELSE 
              IF LEN(OutPutFile) AND UCASE$(MID$(OutPutFile, INSTR(-1, OutPutFile, "\") + 1)) = ufName THEN
                 'ignore eventual existing output file in this run
              ELSE
'                 NewEvents
                 DoProcess Files(ci)
              END IF
        END SELECT
     END IF
  NEXT

  tScan = TIMER - tScan
  IF LEN(OutPutFile) = 0 THEN
     IF doFileExist(FilePathStr + "tflinczy.tmp") = 0 THEN
        OutPutFile = FilePathStr + "tflinczy.tmp"
     END IF
  END IF

  '----------------------------------------------------------------------------
'  NewEvents
  tTot = TIMER

  DoSaveResults OutPutFile, 1, 0

  're-initiate and scan output file, looking for eventual equates
  'and/or structures were embedded in something else and may be missing.
  REDIM equResName(0)    : REDIM equResFull(0)    : cEquRes = 0
  REDIM structResName(0) : REDIM structResFull(0) : cStructRes = 0
  REDIM funcResName(0)   : REDIM funcResFull(0)   : cFuncRes = 0
  REDIM subResName(0)    : REDIM subResFull(0)    : cSubRes = 0
  REDIM ifuncResName(0)  : REDIM ifuncResFull(0)  : icFuncRes = 0
  REDIM isubResName(0)   : REDIM isubResFull(0)   : icSubRes = 0

  DoProcess OutPutFile
  SLEEP 50
'  NewEvents
  '----------------------------------------------------------------------------

  DoSaveResults OutPutFile, 0, 0

  're-initiate and scan output file once more, looking for eventual equates
  'and/or structures were embedded in something else and may be missing.
  REDIM equResName(0)    : REDIM equResFull(0)    : cEquRes = 0
  REDIM structResName(0) : REDIM structResFull(0) : cStructRes = 0
  REDIM funcResName(0)   : REDIM funcResFull(0)   : cFuncRes = 0
  REDIM subResName(0)    : REDIM subResFull(0)    : cSubRes = 0
  REDIM ifuncResName(0)  : REDIM ifuncResFull(0)  : icFuncRes = 0
  REDIM isubResName(0)   : REDIM isubResFull(0)   : icSubRes = 0

  DoProcess OutPutFile
  SLEEP 50
'  NewEvents
'  NewEvents
  '----------------------------------------------------------------------------

  DoSaveResults OutPutFile, 0, 0

  're-initiate and scan output file once more, looking for eventual equates
  'and/or structures were embedded in something else and may be missing.
  REDIM equResName(0)    : REDIM equResFull(0)    : cEquRes = 0
  REDIM structResName(0) : REDIM structResFull(0) : cStructRes = 0
  REDIM funcResName(0)   : REDIM funcResFull(0)   : cFuncRes = 0
  REDIM subResName(0)    : REDIM subResFull(0)    : cSubRes = 0
  REDIM ifuncResName(0)  : REDIM ifuncResFull(0)  : icFuncRes = 0
  REDIM isubResName(0)   : REDIM isubResFull(0)   : icSubRes = 0

  DoProcess OutPutFile
  SLEEP 50
'  NewEvents
'  NewEvents
  '----------------------------------------------------------------------------

  tTot = TIMER - tTot
'  NewEvents

  DoSaveResults OutPutFile, 0, 1 'and save final result, plus load it for preview
  SLEEP 50
'  NewEvents

  IF OutPutFile = FilePathStr + "tflinczy.tmp" THEN    'if we have used a temporary file
     SLEEP 50
'     NewEvents
     IF doFileExist(OutPutFile) THEN KILL OutPutFile  'kill it - take no prisoners..
     OutPutFile = ""
  END IF

  FUNCTION = %TRUE 'return %TRUE on success
END FUNCTION

'
' Load text from file, extract lines and get all subs, functions and globals
' into arrays.
'
FUNCTION DoProcess(BYVAL TheFile AS STRING) AS LONG
  IF doFileExist(TheFile) = 0 THEN EXIT FUNCTION  'if no or only one line, exit

  LOCAL ci AS LONG, p AS LONG, Letter AS BYTE PTR, Letter2 AS BYTE PTR, acByte AS LONG, bcByte AS LONG
  LOCAL QuotePos AS LONG, QuotePos2 AS LONG, di AS LONG, noFlag AS LONG ', inPar AS LONG
  LOCAL POS AS LONG, pos2 AS LONG, wordFlag AS LONG
  LOCAL MainStr AS STRING, sBuf AS STRING, txt AS STRING

'--------------------------------------------------------------------
' load file into MainStr
'--------------------------------------------------------------------
  ci = CreateFile(BYVAL STRPTR(TheFile), %GENERIC_READ, %FILE_SHARE_READ, BYVAL 0&, %OPEN_EXISTING, 0, 0)
  IF ci = %INVALID_HANDLE_VALUE THEN EXIT FUNCTION
  POS   = GetFileSize(ci, 0)
  IF POS > 0 THEN
     MainStr = SPACE$(POS)
     SetFilePointer ci, 0, 0, %FILE_BEGIN
     ReadFile ci, BYVAL STRPTR(MainStr), POS, pos2, BYVAL %NULL
  END IF
  CloseHandle ci
  IF pos2 <> POS THEN EXIT FUNCTION

'  OPEN TheFile FOR BINARY AS #1 LEN = 16383    'open file
'     IF ERR THEN                               'if it failed
'        RESET : ERRCLEAR : EXIT FUNCTION       'reset, clear error and exit
'     END IF
'     GET$ #1, LOF(1), MainStr                  'else load contents into MainStr
'  CLOSE #1                                     'close file

  IF LEN(MainStr) < 2 THEN EXIT FUNCTION       'if MainStr is too short, exit
  REPLACE $TAB WITH SPACE$(4) IN MainStr       'ensure there are no TAB$
  CALL doUCASE(MainStr)                        'make it upper case for compare
  IF TheFile <> OutPutFile THEN gTotLines = gTotLines + TALLY(MainStr, $CR)

'--------------------------------------------------------------------
' scan MainStr and extract lines
'--------------------------------------------------------------------
  p = 1: ci = 0 : ic = 0
  Letter = STRPTR(MainStr)                       'point to beginning of MainStr

  FOR ci = 1 TO LEN(MainStr)
     SELECT CASE @Letter
        CASE 13
           INCR ic                                'increase line- and total line counter
'           IF ic MOD 200 = 0 THEN NewEvents
           p = ci - p
           IF p > 3 AND PEEK(Letter - p) <> 39  THEN GOSUB ExtractLine  'if line is enough long, extract it
           INCR Letter : INCR ci : p = ci + 1    'jump past LF and store position
        CASE 9  : @Letter = 32                   'replace ev. tab with space
     END SELECT
     INCR Letter
  NEXT ci

  IF ci > p + 2 THEN
     INCR ic                   'increase line counter
     p = ci - p
     GOSUB ExtractLine         'if line didn't end with line feed..
  END IF

  FUNCTION = 1
EXIT FUNCTION

'---------------------------------------------------------
' Extract line from main text
'---------------------------------------------------------
ExtractLine:
  txt = PEEK$(Letter - p, p)               'extract line

  '--------------------------------------------------------------------
  ' blank out text within double quotes
  '--------------------------------------------------------------------
  QuotePos = INSTR(txt, $DQ)                   'see if there is any
  IF QuotePos THEN
     DO                                        'loop while there is any left
        QuotePos2 = INSTR(QuotePos + 1, txt, $DQ) 'look for matching pair and blank out text between DQ's
        IF QuotePos2 THEN                         'main reason for this is search for correct ' (rem char)
           MID$(txt, QuotePos, QuotePos2 - QuotePos + 1) = SPACE$(QuotePos2 - QuotePos + 1)
           QuotePos = INSTR(QuotePos2 + 1, txt, $DQ)
           IF QuotePos = 0 THEN EXIT DO
        ELSE
           EXIT DO
        END IF
     LOOP
  END IF

  IF ASC(txt) <> 32 THEN
     txt = EXTRACT$(txt, "'")                      'cut off ev. uncommented part
  ELSE
     txt = LTRIM$(EXTRACT$(txt, "'"))              'cut off ev. uncommented part and trim away leading spaces
  END IF
  acByte = ASC(txt) 'get first letter
  IF acByte = 39 THEN
     RETURN 'if whole line is uncommented, get next
  ELSEIF acByte = 68 AND LEFT$(txt, 5) = "DATA " THEN
     RETURN 'if data statement
  ELSEIF acByte = 82 AND LEFT$(txt, 4) = "REM " THEN
     RETURN 'if whole line in uncommented with REM statement
  END IF
  IF INSTR(txt, " REM ") THEN
     txt = LEFT$(txt, INSTR(txt, " REM "))      'same here, if REM was used
  END IF
  IF INSTR(txt, " _") THEN
     txt = LEFT$(txt, INSTR(txt, " _") + 2)     'if line wraps to next, ignore the rest of it
  END IF
  IF ASC(txt, -1) = 32 THEN txt = RTRIM$(txt)       'trim off trailing spaces

'  IF INSTR(txt, ":") THEN                       'colon inside paranthesis must be converted
'     inPar = 0
'     FOR Letter2 = STRPTR(txt) TO STRPTR(txt) + LEN(txt)
'        SELECT CASE @Letter2
'           CASE 40 : INCR inPar                 'left paranthesis (
'           CASE 41 : DECR inPar                 'right paranthesis )
'           CASE 58 : IF inPar > 0 THEN @Letter2 = 59 'if within paranthesis, convert colon to semicolon (whatever)
'        END SELECT
'     NEXT
'  END IF

  IF LEN(txt) > 3 THEN                          'now, if line is enough long
     IF noFlag = 1 AND (LEFT$(txt, 6) = "#ENDIF" OR LEFT$(txt, 6) = "$ENDIF") THEN noFlag = 0
     IF acByte = 35 AND LEFT$(txt, 3) = "#IF" AND _
          (LEFT$(txt, 21) = "#IF NOT %DEF(%WINAPI)" OR _
           LEFT$(txt, 26) = "#IF NOT %DEF(%LF_FACESIZE)") THEN
        noFlag = 1
     ELSEIF acByte = 36 AND LEFT$(txt, 3) = "$IF" AND _
          (LEFT$(txt, 21) = "$IF NOT %DEF(%WINAPI)" OR _
           LEFT$(txt, 26) = "$IF NOT %DEF(%LF_FACESIZE)") THEN
        noFlag = 1

     ELSEIF noFlag = 0 THEN
        GOSUB ChkLine                   'look at words in line
     END IF
  END IF
RETURN

ChkLine:
  wordFlag = 0
  Letter2 = STRPTR(txt)
  FOR di = 1 TO LEN(txt)
     SELECT CASE @Letter2
        CASE 65 TO 90, 37, 36, 48 TO 57, 95, 192 TO 214, 216 TO 223
'        CASE 97 TO 122, 65 TO 90, 36, 37, 48 TO 57, 95, 192 TO 214, 216 TO 246, 248 TO 255
           IF wordFlag = 0 AND @Letter2 <> 95 THEN 'if valid char and no flag, word starts here (not with underscore)
              wordFlag = 1 : pos = di              'set wordflag and store position
           END IF

        CASE ELSE                       'we hit something else, like space, dot, etc..
           IF wordFlag = 1 THEN         'if flag, then a word is ready
              GOSUB ChkWord             'check what we got
              wordFlag = 0              'and reset wordflag
           END IF
     END SELECT
     INCR Letter2                       'next char
  NEXT

  IF wordFlag  = 1 THEN GOSUB ChkWord 'in case there were letters all the way to the end..
RETURN

ChkWord:
   acByte = di - pos                             'calculate length
   IF acByte < 3 THEN RETURN
   sBuf = PEEK$(Letter2 - acByte, acByte) + CHR$(0) 'grab word, add null char for search
   acByte = ASC(sBuf)
'   INCR isGLOBAL

   IF acByte = 37 OR acByte = 36 THEN  ' % EQUATES, % or $
      acByte = ASC(sBuf, 2) - 65 'get second ASC for indexed search
      IF acByte < 0 THEN
         acByte = 0
      ELSEIF acByte > 26 THEN
         acByte = 26
      END IF
      bcByte = ASC(sBuf, 3) - 65 'get third ASC for advanced indexed search
      IF bcByte < 0 THEN
         bcByte = 0
      ELSEIF bcByte > 26 THEN
         bcByte = 26
      END IF
      ARRAY SCAN equName(equStart(acByte, bcByte)) FOR equCount(acByte, bcByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
      IF pos THEN
         ARRAY SCAN equResName(0) FOR cEquRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
         IF pos2 = 0 THEN
            IF cEquRes MOD 50 = 0 THEN
               REDIM PRESERVE equResName(cEquRes + 50)
               REDIM PRESERVE equResFull(cEquRes + 50)
            END IF
            pos = pos + equStart(acByte, bcByte) - 1
            equResName(cEquRes) = equName(pos)
            equResFull(cEquRes) = equFull(pos)
            INCR cEquRes
         END IF
      END IF

   ELSE ' FIRST FILTER OUT PB KEYWORDS
      acByte = acByte - 65       'get first ASC for indexed search
      IF acByte < 0 THEN
         acByte = 0
      ELSEIF acByte > 26 THEN
         acByte = 26
      END IF
      bcByte = ASC(sBuf, 2) - 65 'get second ASC for advanced indexed search
      IF bcByte < 0 THEN
         bcByte = 0
      ELSEIF bcByte > 26 THEN
         bcByte = 26
      END IF
      ARRAY SCAN pbWords(pbStart(acByte, bcByte)) FOR pbCount(acByte, bcByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
      IF pos THEN RETURN

      'THEN LOOK AMONG TYPE DECLARED STRUCTURES AND UNIONS
      ARRAY SCAN structName(StructStart(acByte, bcByte)) FOR StructCount(acByte, bcByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
      IF pos THEN
         ARRAY SCAN structResName(0) FOR cStructRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
         IF pos2 = 0 THEN
            IF cStructRes MOD 50 = 0 THEN
               REDIM PRESERVE structResName(cStructRes + 50)
               REDIM PRESERVE structResFull(cStructRes + 50)
            END IF
            pos = pos + StructStart(acByte, bcByte) - 1
            structResName(cStructRes) = structName(pos)
            structResFull(cStructRes) = structFull(pos)
            INCR cStructRes
         END IF
      END IF

      IF pos = 0 THEN 'API FUNCTIONS
         ARRAY SCAN funcName(FuncStart(acByte, bcByte)) FOR FuncCount(acByte, bcByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
         IF pos THEN
            ARRAY SCAN funcResName(0) FOR cFuncRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
            IF pos2 = 0 THEN
               IF cFuncRes MOD 50 = 0 THEN
                  REDIM PRESERVE funcResName(cFuncRes + 50)
                  REDIM PRESERVE funcResFull(cFuncRes + 50)
               END IF
               pos = pos + FuncStart(acByte, bcByte) - 1
               funcResName(cFuncRes) = funcName(pos)
               funcResFull(cFuncRes) = funcFull(pos)
               INCR cFuncRes
            END IF
         END IF
      END IF

      IF pos = 0 THEN 'API SUBS
         ARRAY SCAN subName(SubStart(acByte)) FOR SubCount(acByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
         IF pos THEN
            ARRAY SCAN subResName(0) FOR cSubRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
            IF pos2 = 0 THEN
               IF cSubRes MOD 50 = 0 THEN
                  REDIM PRESERVE subResName(cSubRes + 50)
                  REDIM PRESERVE subResFull(cSubRes + 50)
               END IF
               pos = pos + SubStart(acByte) - 1
               subResName(cSubRes) = subName(pos)
               subResFull(cSubRes) = subFull(pos)
               INCR cSubRes
            END IF
         END IF
      END IF

      IF pos = 0 THEN 'FUNCTIONS
         ARRAY SCAN ifuncName(iFuncStart(acByte, bcByte)) FOR iFuncCount(acByte, bcByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
         IF pos THEN
            ARRAY SCAN ifuncResName(0) FOR icFuncRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
            IF pos2 = 0 THEN
               IF icFuncRes MOD 50 = 0 THEN
                  REDIM PRESERVE ifuncResName(icFuncRes + 50)
                  REDIM PRESERVE ifuncResFull(icFuncRes + 50)
               END IF
               pos = pos + iFuncStart(acByte, bcByte) - 1
               ifuncResName(icFuncRes) = ifuncName(pos)
               ifuncResFull(icFuncRes) = ifuncFull(pos)
               INCR icFuncRes
            END IF
         END IF
      END IF

      IF pos = 0 THEN 'SUBS
         ARRAY SCAN isubName(iSubStart(acByte)) FOR iSubCount(acByte), FROM 1 TO LEN(sBuf), = sBuf, TO pos
         IF pos THEN
            ARRAY SCAN isubResName(0) FOR icSubRes, FROM 1 TO LEN(sBuf), = sBuf, TO pos2
            IF pos2 = 0 THEN
               IF icSubRes MOD 10 = 0 THEN
                  REDIM PRESERVE isubResName(icSubRes + 10)
                  REDIM PRESERVE isubResFull(icSubRes + 10)
               END IF
               pos = pos + iSubStart(acByte) - 1
               isubResName(icSubRes) = isubName(pos)
               isubResFull(icSubRes) = isubFull(pos)
               INCR icSubRes
            END IF
         END IF
      END IF

      IF pos = 0 AND ghDev = 0 AND acByte = 18 AND LEN(sBuf) > 12 THEN 'S=83 - 65 = 18  inclComDlg32
         IF sBuf = "SAVE_HDEVMODE" + CHR$(0) OR sBuf = "SAVE_HDEVNAMES"  + CHR$(0) THEN ghDev = 1
      END IF

   END IF

RETURN

END FUNCTION

'
' Save results to output file
'
SUB DoSaveResults (BYVAL theFile AS STRING, BYVAL Run0 AS LONG, BYVAL realSave AS LONG)
  LOCAL ci AS LONG, globalFlag AS LONG, txt AS STRING
  IF cEquRes THEN
     REDIM PRESERVE equResName(cEquRes - 1)
     REDIM PRESERVE equResFull(cEquRes - 1)
     ARRAY SORT equResFull()
  END IF

  IF cStructRes THEN
     REDIM PRESERVE structResName(cStructRes - 1)
     REDIM PRESERVE structResFull(cStructRes - 1)
     ARRAY SORT structResFull()
  END IF

  IF cFuncRes THEN
     REDIM PRESERVE funcResName(cFuncRes - 1)
     REDIM PRESERVE funcResFull(cFuncRes - 1)
     IF realSave THEN ARRAY SORT funcResName(), TAGARRAY funcResFull()
  END IF

  IF cSubRes THEN
     REDIM PRESERVE subResName(cSubRes - 1)
     REDIM PRESERVE subResFull(cSubRes - 1)
     IF realSave THEN ARRAY SORT subResName(), TAGARRAY subResFull()
  END IF

  IF icFuncRes THEN
     REDIM PRESERVE ifuncResName(icFuncRes - 1)
     REDIM PRESERVE ifuncResFull(icFuncRes - 1)
     IF realSave THEN ARRAY SORT ifuncResFull(), TAGARRAY ifuncResName()
  END IF

  IF icSubRes THEN
     REDIM PRESERVE isubResName(icSubRes - 1)
     REDIM PRESERVE isubResFull(icSubRes - 1)
     IF realSave THEN ARRAY SORT isubResFull()
  END IF

  OPEN OutPutFile FOR OUTPUT AS #1 LEN = 16383
     IF ERR THEN
        RESET : ERRCLEAR
        BEEP : EXIT SUB
     END IF

     PRINT #1,"' Main source code file: " + FilePathStr + FileNameStr
     IF UBOUND(Files) > 1 THEN
        FOR ci = 0 TO UBOUND(Files) - 1
           IF FilePathStr + FileNameStr <> Files(ci) THEN
              PRINT #1,"' Additional code file : " + Files(ci)
           END IF
        NEXT
     END IF
     PRINT #1,"'================================================================="

     PRINT #1,"' Replace #INCLUDE file : " + Win32ApiFile
     IF inclCommCtrl THEN PRINT #1,"' Replace #INCLUDE file : " + sIncDir(0) + "Commctrl.inc"
     IF inclComDlg32 THEN PRINT #1,"' Replace #INCLUDE file : " + sIncDir(0) + "Comdlg32.inc"
     IF inclRichEdit THEN PRINT #1,"' Replace #INCLUDE file : " + sIncDir(0) + "Richedit.inc"
     IF inclMdi32    THEN PRINT #1,"' Replace #INCLUDE file : " + sIncDir(0) + "Mdi32.inc"

     PRINT #1,""
     IF LEN(OutPutFile) THEN
        PRINT #1,"' With #INCLUDE file    : " + OutPutFile
     ELSE
        PRINT #1,"' Saved as:  No output file name was given - no replacement file created!"
     END IF
     IF realSave THEN
        tTotAll = TIMER - tTotAll

        PRINT #1,"'================================================================="
        PRINT #1,"' Created by inClean2.dll v1.31, " + DATE$ + ", " + TIME$
'        PRINT #1,"' See incLean2.txt for some useful information and tips."
'        PRINT #1,"'"

'        txt = "'" + STR$(gIncLine) + " lines of include file data read in " + _
'                    FORMAT$(tRead, "0.00") + " seconds."
'        IF tRead THEN txt = txt + " (" + FORMAT$(gIncLine / tRead, "0") + " lines/sec.)"
'        PRINT #1, txt

'        txt = "'" + STR$(gTotLines) + " lines of code scanned and compared in " + _
'                        FORMAT$(tScan, "0.00") + " seconds."
'        IF tRead THEN txt = txt + " (" + FORMAT$(gTotLines / tScan, "0") + " lines/sec.)"
'        PRINT #1, txt

'        PRINT #1, "' ouput file check took " FORMAT$(tTot, "0.00") + " seconds."
'        PRINT #1, "' Entire process took " FORMAT$(tTotAll, "0.00") + " seconds."

        PRINT #1, "' " + USING$("######", gIncLine) + " lines of include file data read and compared against"
        PRINT #1, "' " + USING$("######", gTotLines) + " lines of code in " + FORMAT$(tTotAll, "0.00") + " seconds."
        
     END IF
     PRINT #1,"'"

     IF cEquRes THEN
        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' Equates: " + STR$(cEquRes + Run0)
        PRINT #1,"'-----------------------------------------------------------------"
        IF Run0 = 1 THEN PRINT #1, "%WINAPI = 1"
        FOR ci = 0 TO cEquRes -1
           PRINT #1, MID$(equResFull(ci), 9)
        NEXT
        PRINT #1,""
     END IF

'     PRINT #1, "%INCLEAN2_DLL                                   = 1"
'     IF cEquRes THEN
'        IF Run0 = 1 THEN
'           PRINT #1, "%WINAPI = 1"
'        END IF
'        FOR ci = 0 TO cEquRes -1
'           PRINT #1, MID$(equResFull(ci), 9)
'        NEXT
'        PRINT #1,""
'     END IF

     IF cStructRes THEN
        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' TYPE and UNION structures: " + STR$(cStructRes)
        PRINT #1,"'-----------------------------------------------------------------"
        FOR ci = 0 TO cStructRes -1
           'IF Run0 = 0 AND realSave = 0 THEN MSGBOX MID$(structResFull(ci), 9)
           PRINT #1, MID$(structResFull(ci), 9)
        NEXT
     END IF

     IF cFuncRes THEN
        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' Declared Functions: " + STR$(cFuncRes)
        PRINT #1,"'-----------------------------------------------------------------"
        FOR ci = 0 TO cFuncRes -1
           PRINT #1, funcResFull(ci)
        NEXT
        PRINT #1,""
     END IF

     IF cSubRes THEN
        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' Declared Subs: " + STR$(cSubRes)
        PRINT #1,"'-----------------------------------------------------------------"
        FOR ci = 0 TO cSubRes -1
           PRINT #1, subResFull(ci)
        NEXT
        PRINT #1,""
     END IF

     IF icFuncRes OR ghDev THEN
        IF ghDev THEN
           globalFlag = 1
        ELSE
           FOR ci = 0 TO icFuncRes -1
              IF globalFlag = 0 AND ASC(ifuncResName(ci)) = 80 AND _
                 (ifuncResName(ci) = "PRINTDLG" + CHR$(0) OR _
                    ifuncResName(ci) = "PRINTERDIALOG" + CHR$(0) OR _
                       ifuncResName(ci) = "PRINTERSETUP" + CHR$(0)) THEN
                 globalFlag = 1
                 EXIT FOR
              END IF
           NEXT
        END IF
        IF globalFlag THEN
           PRINT #1,"'-----------------------------------------------------------------"
           PRINT #1,"' Global variables for PrintDlg and/or PrinterDialog functions:"
           PRINT #1,"'-----------------------------------------------------------------"
           PRINT #1,"GLOBAL save_hDevMode  AS LONG  ' for retaining printer selection"
           PRINT #1,"GLOBAL save_hDevNames AS LONG  ' info during the entire process"
           PRINT #1,""
        END IF

        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' Functions: " + STR$(icFuncRes) + "  (begins with declarations)"
        PRINT #1,"'-----------------------------------------------------------------"
        FOR ci = 0 TO icFuncRes -1
           txt = MID$(ifuncResFull(ci), 9)
           REPLACE " EXPORT " WITH " " IN txt
           PRINT #1, GetRoutineDeclare(txt)
        NEXT
        PRINT #1,"'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -"
        FOR ci = 0 TO icFuncRes -1
           PRINT #1, MID$(ifuncResFull(ci), 9)
        NEXT
     END IF

     IF icSubRes THEN
        PRINT #1,"'-----------------------------------------------------------------"
        PRINT #1,"' Subs: " + STR$(icSubRes) + "  (begins with declarations)"
        PRINT #1,"'-----------------------------------------------------------------"
        FOR ci = 0 TO icSubRes -1
           txt = MID$(isubResFull(ci), 9)
           REPLACE " EXPORT " WITH " " IN txt
           PRINT #1, GetRoutineDeclare(txt)
        NEXT
        PRINT #1,"'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -"
        FOR ci = 0 TO icSubRes -1
           PRINT #1, MID$(isubResFull(ci), 9)
        NEXT
     END IF

  CLOSE #1

END SUB

'************************************************************************
' Get declare for given routine
'************************************************************************
FUNCTION GetRoutineDeclare(BYVAL txt AS STRING) AS STRING
  IF LEN(txt) THEN
     LOCAL ci AS LONG, di AS LONG, p AS LONG, isWrapped AS LONG, isFirstLine AS LONG, indDQ AS LONG, _
     Letter AS BYTE PTR, Letter2 AS BYTE PTR, txt2 AS STRING, txt3 AS STRING, buf AS STRING

     Letter = STRPTR(txt) : p = 1            'point to beginning of txt
     FOR ci = 1 TO LEN(txt)
        SELECT CASE @Letter
           CASE 13
              txt2 = MID$(txt, p, ci - p)     'extract line
              buf = txt2
              GOSUB DoStripRem

              IF isFirstLine = 0 THEN
                 IF ASC(txt2, -1) = 95 THEN
                    txt3 = "DECLARE " + buf + $CRLF
                    isWrapped = 1
                 ELSE
                    FUNCTION = "DECLARE " + buf
                    EXIT FUNCTION
                 END IF
                 isFirstLine = 1
              ELSE
                 IF isWrapped THEN
                    txt3 = txt3 + SPACE$(8) + buf
                    IF ASC(txt2, -1) <> 95 THEN
                       FUNCTION = txt3
                       EXIT FUNCTION
                    END IF
                    txt3 = txt3 + $CRLF
                 END IF
              END IF

              INCR Letter : INCR ci : p = ci + 1  'jump past LF and store position
        END SELECT
        INCR Letter
     NEXT ci

  END IF

DoStripRem:
  IF ASC(txt2) = 39 THEN RETURN  'if whole line in uncommented
  Letter2 = STRPTR(txt2)         'point to beginning of line
  FOR di = 1 TO LEN(txt2)
     SELECT CASE @Letter2
        CASE 34 'DQ
           IF indDQ = 0 THEN indDQ = 1 ELSE indDQ = 0
        CASE 39 'rem character, '
           IF indDQ = 0 THEN
              txt2 = RTRIM$(LEFT$(txt2, di-1))
              EXIT FOR
           END IF
     END SELECT
     INCR Letter2
  NEXT di
  RETURN

END FUNCTION

'
' doFileExist - make sure a file or folder exists
'
FUNCTION doFileExist ALIAS "doFileExist" (BYVAL sfName AS STRING) EXPORT AS LONG
  LOCAL hRes AS DWORD, tWFD AS WIN32_FIND_DATA

  IF ASC(sfName, -1) = 92 THEN _              'if a path with trailing backslash
     sfName = LEFT$(sfName, LEN(sfName) - 1)  'remove trailing backslash, \
  IF ASC(sfName, -1) = 47 THEN _              'if a path with trailing slash
     sfName = LEFT$(sfName, LEN(sfName) - 1)  'remove trailing slash, /

  hRes = FindFirstFile(BYVAL STRPTR(sfName), tWFD)
  IF hRes <> %INVALID_HANDLE_VALUE THEN
     FUNCTION = %TRUE
     FindClose hRes
  END IF
END FUNCTION

'
' doUCASE routine, alters given string directly - very fast..
'
SUB doUCASE(a$)
  IF LEN(a$) = 0 THEN EXIT SUB
  #REGISTER NONE

  ! mov eax, a$            ; eax = pointer to string handle
  ! mov eax, [eax]         ; eax = pointer to string data
  ! mov ecx, [eax-4]       ; move length of string into ecx

  BgnUpLoop:
     ! mov dl, [eax]       ; move current char into dl
     ! cmp dl, 97          ; compare against value 97 (a)
     ! jb NoDnChar         ; if dl < 97 it is in 0-97 range, do nothing - get next
     ! cmp dl, 123         ; compare against value 123
     ! jb MakeUpper        ; if dl < 123 it is in 97-122 range, make Upper case and get next
     ! cmp dl, 224         ; compare against value 224 () - extended ANSI characters
     ! jb NoDnChar         ; if dl < 224 it is in 123-223 range, do nothing - get next
     ! cmp dl, 247         ; compare against value 247 ()
     ! jb MakeUpper        ; if dl < 247 it is in 224-246 range, make Upper case and get next
     ! je NoDnChar         ; else dl = 247 (), do nothing - get next
     ! cmp dl, 255         ; compare against value 255 ()
     ! jb MakeUpper        ; if dl < 255 it is in 248-254 range, make Upper case and get next
     ! jmp NoDnChar        ; else dl = 255, do nothing - get next

  MakeUpper:
     ! sub dl, 32          ; make uppercase subtracting 32 from dl's value
     ! mov [eax], dl       ; write changed char back into a$

  NoDnChar:
     ! inc eax             ; get next character
     ! dec ecx             ; decrease ecx (length) counter
     ! jnz bgnUpLoop       ; iterate if not zero

END SUB

'
' doUCASER function, returns UCASE string without altering original
'
FUNCTION doUCASER(BYVAL st AS STRING) AS STRING
  #REGISTER NONE
  LOCAL p AS STRING PTR
  p = STRPTR(st)

  ! mov eax, p              ; move pointer to string into eax
  ! mov ecx, [eax-4]        ; move length of string into ecx (counter)
  ! cmp ecx, 0              ; compare length with 0
  ! je exitedmUCASER           ; if it equals 0 (len = 0), then exit

  beginedmUCASER:
     ! mov dl, [eax]        ; move current char into dl
     ! cmp dl, 97           ; compare against value 97 (a)
     ! jb nextedmUCASER     ; if dl < 97  then get next character
     ! cmp dl, 123          ; compare against value 123
     ! jb makeedmUCASER     ; if dl < 123 it is in 97-122 range, make Uppercase and get next
     ! cmp dl, 224          ; compare against value 224 () - extended ANSI
     ! jb nextedmUCASER     ; if dl < 224 it is in 123-224 range, do nothing to it
     ! cmp dl, 247          ; compare against value 247
     ! jb makeedmUCASER     ; if dl < 247 it is in 224-247 range, make Uppercase and get next
     ! je nextedmUCASER     ; if dl = 247, do nothing
     ! cmp dl, 255          ; compare against value 255
     ! jb makeedmUCASER     ; if dl < 255 it is in 248-255 range, make Uppercase and get next
     ! jmp nextedmUCASER    ; else, on to next character

  makeedmUCASER:
     ! sub dl, 32           ; make lowercase by subtracting 32 from dl (which holds asc value)
     ! mov [eax], dl        ; move changed char back into eax and fall through to nextedmUCASER

  nextedmUCASER:
     ! inc eax              ; get next character
     ! dec ecx              ; decrease ecx (length) counter
     ! jnz beginedmUCASER   ; iterate if not zero (end of string)
     FUNCTION = st          ' ecx was 0, return result on exit

  exitedmUCASER:
END FUNCTION

'
' sort and index given array
'
SUB IndexArray(aName() AS STRING, aFull() AS STRING, aStart() AS LONG, aCount() AS LONG)
  LOCAL ci AS LONG, acByte AS LONG, bcByte AS LONG

  ARRAY SORT aName(), TAGARRAY aFull()  'index Structure array
  acByte = MAX&(0, ASC(aName(0)) - 65)
  aStart(acByte) = 0

  FOR ci = 1 TO UBOUND(aName)
     bcByte = MAX&(0, ASC(aName(ci)) - 65)
     IF bcByte > acByte THEN 'reached next character
       aCount(acByte) = ci - 1
       aStart(bcByte) = ci
       acByte = bcByte
     END IF
  NEXT ci
  aCount(bcByte) = ci - 1

  FOR ci = 0 TO UBOUND(aCount)
     aCount(ci) = aCount(ci) - aStart(ci) + 1
  NEXT

END SUB

'
' sort and double-index given array
'
SUB IndexArray2(aName() AS STRING, aFull() AS STRING, _
                aStart() AS LONG, aCount() AS LONG, BYVAL special AS LONG)
  LOCAL ci AS LONG, di AS LONG, acByte AS LONG, bcByte AS LONG

  IF special THEN
     ARRAY SORT aName(), TAGARRAY aFull()  'sort array
  ELSE
     ARRAY SORT aName()  'sort pb keywords array
  END IF
'------------------------------------------------------------------------------
  acByte = MAX&(0, ASC(aName(0)) - 65)             'need to look at pos 2
  aStart(acByte, 26) = 0

  FOR ci = 1 TO UBOUND(aName)
     bcByte = MAX&(0, ASC(aName(ci)) - 65)
     IF bcByte > 26 THEN bcByte = 26 'CALL AcByteProc(bcByte)
     IF bcByte > acByte THEN 'reached next character
       aCount(acByte, 26) = ci - 1
       aStart(bcByte, 26) = ci
       acByte = bcByte
     END IF
  NEXT ci
  aCount(bcByte, 26) = ci - 1

  FOR ci = 0 TO UBOUND(aCount)
     FOR di = 0 TO UBOUND(aCount)
        aStart(ci, di) = aStart(ci, 26)
        aCount(ci, di) = aCount(ci, 26) '- aStart(ci, 26) + 1
     NEXT di
  NEXT ci
'------------------------------------------------------------------------------
  FOR ci = 0 TO 25
     IF LEN(aName(aStart(ci, 26))) > 1 THEN 'check first word
        acByte = MAX&(0, ASC(aName(aStart(ci, 26))) - 65)
        IF acByte > 26 THEN acByte = 0 'CALL AcByteProc(acByte)
     ELSE
        acByte = 0
     END IF

     FOR di = aStart(ci, 26) TO aCount(ci, 26)
        IF LEN(aName(di)) > 2 THEN
           bcByte = MAX&(0, ASC(aName(di)) - 65)
           IF bcByte > 26 THEN bcByte = 0 'CALL AcByteProc(bcByte)
        ELSE
           bcByte = 0
        END IF

        IF bcByte > acByte THEN 'reached next second character
           aCount(ci, acByte) = di - 1
           aStart(ci, bcByte) = di
           acByte = bcByte
        END IF
     NEXT di
     aCount(ci, acByte) = di - 1 '2
  NEXT ci

  FOR ci = 0 TO UBOUND(aCount)
     FOR di = 0 TO UBOUND(aCount)
        aCount(ci, di) = aCount(ci, di) - aStart(ci, di) + 1
     NEXT di
  NEXT ci

END SUB

'
' sort and double-index given array, based on second and third character (equates)
'
SUB IndexEquates2(aName() AS STRING, aFull() AS STRING, aStart() AS LONG, aCount() AS LONG)
  LOCAL ci AS LONG, di AS LONG, acByte AS LONG, bcByte AS LONG

  ARRAY SORT aName(), FROM 2 TO 40, TAGARRAY aFull()  'sort array
'------------------------------------------------------------------------------
  acByte = MAX&(0, ASC(aName(0), 2) - 65)             'need to start look at pos 2
  aStart(acByte, 26) = 0

  FOR ci = 1 TO UBOUND(aName)
     bcByte = MAX&(0, ASC(aName(ci), 2) - 65)
     IF bcByte > 26 THEN bcByte = 26 'CALL AcByteProc(bcByte)
     IF bcByte > acByte THEN 'reached next character
       aCount(acByte, 26) = ci - 1
       aStart(bcByte, 26) = ci
       acByte = bcByte
     END IF
  NEXT ci
  aCount(bcByte, 26) = ci - 1

  FOR ci = 0 TO UBOUND(aCount)
     FOR di = 0 TO UBOUND(aCount)
        aStart(ci, di) = aStart(ci, 26)
        aCount(ci, di) = aCount(ci, 26) '- aStart(ci, 26) + 1
     NEXT di
  NEXT ci
'------------------------------------------------------------------------------
  FOR ci = 0 TO 25
     IF LEN(aName(aStart(ci, 26))) > 2 THEN 'check first word
        acByte = MAX&(0, ASC(aName(aStart(ci, 26)), 3) - 65)
        IF acByte > 26 THEN acByte = 0 'CALL AcByteProc(acByte)
     ELSE
        acByte = 0
     END IF

     FOR di = aStart(ci, 26) TO aCount(ci, 26)
        IF LEN(aName(di)) > 2 THEN
           bcByte = MAX&(0, ASC(aName(di), 3) - 65)
           IF bcByte > 26 THEN bcByte = 0 'CALL AcByteProc(bcByte)
        ELSE
           bcByte = 0
        END IF

        IF bcByte > acByte THEN 'reached next second character
           aCount(ci, acByte) = di - 1
           aStart(ci, bcByte) = di
           acByte = bcByte
        END IF
     NEXT di
     aCount(ci, acByte) = di - 1 '2
  NEXT ci

  FOR ci = 0 TO UBOUND(aCount)
     FOR di = 0 TO UBOUND(aCount)
        aCount(ci, di) = aCount(ci, di) - aStart(ci, di) + 1
     NEXT di
  NEXT ci

'  FOR ci = 0 TO 28
'     MSGBOX STR$(ci) & " " & STR$(aStart(ci, 26)) & " " & STR$(aCount(ci, 26)) & " " & _
'            aName(aStart(ci, 26)) & STR$(aStart(ci, 26) + aCount(ci, 26))
'  NEXT ci
END SUB

'
' Check to see if the file has a #COMPILE metastatement
'
FUNCTION IsFileMain(BYVAL fName AS STRING) AS LONG
  IF doFileExist(fName) = 0 THEN EXIT FUNCTION
  LOCAL hFile AS LONG, txt AS STRING

  hFile = FREEFILE                           'get a free file handle
  OPEN fName FOR INPUT AS hFile LEN = 16383  'open file

  IF ERR THEN                                'if it failed
     RESET : ERRCLEAR                        'reset, clear error
     FUNCTION = -2 : EXIT FUNCTION           'return -2 to indicate failure and exit
  END IF

  IF LOF(hFile) = 0 THEN                     'if zero length file
     CLOSE hFile                             'close it
     FUNCTION = -3 : EXIT FUNCTION           'return -3 to indicate empty file and exit
  END IF

  DO WHILE EOF(hFile) = 0                    'loop through file
     LINE INPUT# hFile, txt                  'line by line
     REPLACE $TAB WITH SPACE$(4) IN txt      'ensure there are no TAB$
     IF ASC(txt) <> 39 AND LEN(txt) > 8 THEN 'if nor remmed out and enough long
        IF ASC(txt) <> 32 THEN
           txt = UCASE$(txt)                 'adjust txt for compare
        ELSE
           txt = UCASE$(LTRIM$(txt))         'if leading space %USEMACROS
        END IF

        IF (ASC(txt) = 35 OR ASC(txt) = 36) AND MID$(txt, 2, 8) = "COMPILE " THEN
           FUNCTION = 1
           EXIT DO
        END IF

        IF LEFT$(txt, 9) = "FUNCTION " OR _  'jump out once we hit a Sub or Function
                LEFT$(txt, 4) = "SUB " OR _
                   LEFT$(txt, 9) = "CALLBACK " OR _
                      LEFT$(txt, 7) = "STATIC " THEN

'           FUNCTION = LOF(hFile) 'return length
           EXIT DO
        END IF
     END IF
  LOOP
  CLOSE hFile

END FUNCTION

'
' Redim and load a received array with data
'
FUNCTION LoadPBdata2(dArray() AS STRING) AS LONG
  LOCAL ii AS LONG, rc AS LONG

  rc = DATACOUNT
  REDIM dArray(rc - 1) AS STRING 'zero based, so -1
  REDIM pbStart(26, 26) AS LONG
  REDIM pbCount(26, 26) AS LONG

  FOR ii = 1 TO rc                  'read the data into the array
     dArray(ii-1) = UCASE$(READ$(ii)) + CHR$(0)
  NEXT

  IndexArray2 dArray(), dArray(), pbStart(), pbCount(), 0

  '----------------------------------
  FUNCTION = rc  'Return the count, in case we ever should need it..

'DATA #BLOAT, #COMPILE, #DEBUG, #DIM, #ELSE, #ELSEIF, #ENDIF, #IF, #INCLUDE, #OPTION, #REGISTER, #RESOURCE
'DATA #SEGMENT, #STACK, #TOOLS, $BEL, $BS, $COMPILE, $CR, $CRLF, $DEBUG, $DIM, $DQ, $ELSE, $ELSEIF, $ENDIF
'DATA $EOF, $ESC, $FF, $IF, $INCLUDE, $LF, $NUL, $OPTION, $REGISTER, $RESOURCE, $SEGMENT, $SPC, $STACK
'DATA $TAB, $VT, %DEF, %FALSE, %NULL, %PB_EXE, %TRUE
DATA ABS, ACCEL, ACCEPT, ACCESS, ACODE$, ADD, ADDR, ALIAS, ALL, AND, ANY, APPEND, ARRAY, ARRAYATTR
DATA AS, ASC, ASCEND, ASCIZ, ASCIIZ, AT, ATN, ATTACH, ATTRIB, BAR, BASE, BAUD, BDECL, BEEP
DATA BIN$, BINARY, BIT, BITS%, BITS&, BITS?, BITS??, BITS???, BREAK, BUTTON, BYCMD, BYCOPY, BYREF
DATA BYTE, BYVAL, CALC, CALL, CALLBACK, CALLSTK, CALLSTK$, CALLSTKCOUNT, CASE, CATCH, CBCTL, CBCTLMSG
DATA CBHNDL, CBLPARAM, CBMSG, CBWPARAM, CBYT, CCUR, CCUX, CD, CDBL, CDECL, CDWD, CEIL, CEXT, CHDIR
DATA CHDRIVE, CHECK, CHECK3STATE, CHECKBOX, CHOOSE, CHOOSE&, CHOOSE%, CHOOSE$, CHR$, CINT, CLIENT, CLNG
DATA CLOSE, CLS, CLSID$, CODEPTR, COLLATE, COLOR, COMBOBOX, COMM, COMMAND$, CON, CONNECT, CONST, CONTROL
DATA COS, CQUD, CREATE, CSET, CSET$, CSNG, CTSFLOW, CUR, CURDIR$, CURRENCY, CURRENCYX, CUX, CVBYT, CVCUR
DATA CVCUX, CVD, CVDWD, CVE, CVI, CVL, CVQ, CVS, CVWRD, CWRD, DATA, DATACOUNT, DATE$, DECLARE, DECR, DEFAULT
DATA DEFBYT, DEFCUR, DEFCUX, DEFDBL, DEFDWD, DEFEXT, DEFINT, DEFLNG, DEFQUD, DEFSNG, DEFSTR, DEFWRD, DELETE
DATA DESCEND, DIALOG, DIM, DIR$, DISABLE, DISKFREE, DISKSIZE, DISPATCH, DLL, DLLMAIN, DO, DOEVENTS, DOUBLE
DATA DOWN, DRAW, DSRFLOW, DSRSENS, DTRFLOW, DTRLINE, DWORD, ELSE, ELSEIF, EMPTY, ENABLE, END, ENVIRON$
DATA EOF, EQV, ERASE, ERR, ERRAPI, ERRCLEAR, ERROR, ERROR$, EXE, EXIT, EXP, EXP10, EXP2, EXPLICIT, EXPORT
DATA EXT, EXTENDED, EXTRACT$, FILEATTR, FILECOPY, FILENAME$, FILESCAN, FILL, FINALLY, FIX, FLOW, FLUSH, FOCUS
DATA FONT, FOR, FORMAT$, FORMFEED, FRAC, FRAME, FREEFILE, FROM, FUNCTION, FUNCNAME$, GET, GET#, GET$
DATA GETATTR, GLOBAL, GOSUB, GOTO, GUID$, GUIDTXT$, HANDLE, HEX$, HIBYT, HIINT, HIWRD, HOST, ICASE, ICON
DATA IDN, IF, IFACE, IIF, IIF&, IIF%, IIF$, IMAGE, IMAGEX, IMGBUTTON, IMGBUTTONX, IMP, IN, INCR, INP, INOUT
DATA INPUT, INPUT#, INPUTBOX$, INSERT, INSTR, INT, INTERFACE, INTEGER, INV, ISFALSE, ISNOTHING
DATA ISOBJECT, ISTRUE, ITERATE, JOIN$, KILL, LABEL, LBOUND, LCASE$, LEFT, LEFT$, LEN, LET, LIB, LIBMAIN
DATA LINE, LISTBOX, LOBYT, LOC, LOCAL, LOCK, LOF, LOG, LOG10, LOG2, LOINT, LONG, LOOP, LOWRD, LPRINT
DATA LSET, LSET$, LTRIM$, MACRO, MACROTEMP, MAIN, MAKDWD, MAKINT, MAKLNG, MAKPTR, MAKWRD, MAT, MAX, MAX$
DATA MAX%, MAX&, MCASE$, MEMBER, MENU, MID$, MIN, MIN$, MIN%, MIN&, MKBYT$, MKCUR$, MKCUX$, MKD$
DATA MKDIR, MKDWD$, MKE$, MKI$, MKL$, MKQ$, MKS$, MKWRD$, MOD, MODAL, MODELESS, MOUSEPTR, MSGBOX
DATA NAME, NEW, NEXT, NONE, NOT, NOTHING, NOTIFY, NULL, OBJACTIVE, OBJECT, OBJPTR, OBJRESULT, OCT$, OF
DATA OFF, ON, OPEN, OPT, OPTION, OPTIONAL, OR, OUT, OUTPUT, PAGE, PARITY, PARITYCHAR, PARITYREPL, PARITYTYPE
DATA PARSE, PARSE$, PARSECOUNT, PBD, PBMAIN, PEEK, PEEK$, PIXELS, POINTER, POKE, POKE$, POPUP, PORT, POST
DATA PRESERVE, PRINT, PRINT#, PRIVATE, PROFILE, PROGID$, PTR, PUT, PUT$, QUAD, QWORD, RANDOM, RANDOMIZE, READ
DATA READ$, RECEIVE, RECORDS, RECV, REDIM, REDRAW, REGEXPR, REGISTER, REGREPL, REMAIN$, REMOVE$, REPEAT$
DATA REPLACE, RESET, RESUME, RET16, RET32, RET87, RETAIN$, RETP16, RETP32, RETPRM, RETURN, RGB, RIGHT
DATA RIGHT$, RING, RLSD, RMDIR, RND, ROTATE, ROUND, RSET, RSET$, RTRIM$, RTSFLOW, RXBUFFER, RXQUE, SCAN
DATA SCROLLBAR, SDECL, SEEK, SELECT, SEND, SERVER, SET, SETATTR, SETEOF, SGN, SHARED, SHELL
DATA SHIFT, SHOW, SIGNED, SIN, SINGLE, SIZE, SIZEOF, SLEEP, SORT, SPACE$, SPC, SQR, STATE, STATIC, STATUS
DATA STDCALL, STEP, STOP, STR$, STRDELETE$, STRING, STRING$, STRINSERT$, STRPTR, STRREVERSE$, SUB, SUSPEND
DATA SWAP, SWITCH, SWITCH&, SWITCH%, SWITCH$, TAB, TAB$, TAGARRAY, TALLY, TAN, TCP, TEXT, TEXTBOX, THEN
DATA THREAD, THREADCOUNT, THREADID, TIME$, TIMEOUT, TIMER, TO, TOGGLE, TRACE, TRIM$, TRN, TRY, TXBUFFER
DATA TXQUE, TYPE, UBOUND, UCASE, UCASE$, UCODE$, UDP, UNION, UNITS, UNLOCK, UNTIL, UP, USER, USING, USING$
DATA VAL, VARIANT, VARIANT#, VARIANT$, VARIANTVT, VARPTR, VERIFY, VERSION3, VERSION4, VERSION5
DATA WEND, WHILE, WIDTH, WIDTH#, WINMAIN, WITH, WORD, WRITE, WRITE#, XOR, XINPFLOW, XOUTFLOW, ZER

END FUNCTION

'
' Custom DoEvents
'
SUB NewEvents
  LOCAL Msg AS TAGMSG
  WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE)
     TranslateMessage Msg
     DispatchMessage Msg
  WEND
END SUB

'
' read inc file into arrays - time to chew up a couple of MB's memory.. :)
'
FUNCTION ReadIncFile(BYVAL incFile AS STRING, _
                     BYVAL whatRun AS LONG, BYVAL lastRun AS LONG) AS LONG

  IF doFileExist(incFile) = 0 THEN EXIT FUNCTION

  LOCAL ci AS LONG, p AS LONG, pos AS LONG, pos2 AS LONG, tAsc AS LONG, Letter AS BYTE PTR
  LOCAL StructFlag AS LONG, FuncFlag AS LONG, SubFlag AS LONG, QuotePos AS LONG, QuotePos2 AS LONG, _
        iFuncFlag AS LONG, iSubFlag AS LONG, skipFlag AS LONG, equWrapFlag AS LONG, _
        isRichEdit AS LONG, isWin32API AS LONG, skipFlag2 AS LONG
  LOCAL LineStr2 AS STRING

'  NewEvents

  IF whatRun = 0 THEN
     cEqu = 0 : cStruct= 0 : cFunc = 0 : cSub = 0 : cFunc2 = 0 : cSub2 = 0 : gIncLine = 0
     REDIM equName(0)          : REDIM equFull(0)          ': NewEvents
     REDIM equStart(26, 26)    : REDIM equCount(26, 26)    ': NewEvents
     REDIM structName(0)       : REDIM structFull(0)       ': NewEvents
     REDIM StructStart(26, 26) : REDIM StructCount(26, 26) ': NewEvents
     REDIM funcName(0)         : REDIM funcFull(0)         ': NewEvents
     REDIM FuncStart(26, 26)   : REDIM FuncCount(26, 26)   ': NewEvents
     REDIM subName(0)          : REDIM subFull(0)          ': NewEvents
     REDIM SubStart(26)        : REDIM SubCount(26)        ': NewEvents
     REDIM ifuncName(0)        : REDIM ifuncFull(0)        ': NewEvents
     REDIM iFuncStart(26, 26)  : REDIM iFuncCount(26, 26)  ': NewEvents
     REDIM isubName(0)         : REDIM isubFull(0)         ': NewEvents
     REDIM iSubStart(26)       : REDIM iSubCount(26)       ': NewEvents
  END IF

  ci = CreateFile(BYVAL STRPTR(incFile), %GENERIC_READ, %FILE_SHARE_READ, BYVAL 0&, %OPEN_EXISTING, 0, 0)
  IF ci = %INVALID_HANDLE_VALUE THEN
     EXIT FUNCTION
  END IF
  POS   = GetFileSize(ci, 0)
  IF POS > 0 THEN
     sTemp  = SPACE$(POS)
     SetFilePointer ci, 0, 0, %FILE_BEGIN
     ReadFile ci, BYVAL STRPTR(sTemp), POS, pos2, BYVAL %NULL
  END IF
  CloseHandle ci
  IF pos2 <> POS THEN EXIT FUNCTION

'  OPEN incFile FOR BINARY AS #1 LEN = 8000 '16383
'     IF ERR THEN
'        FUNCTION = 0
'        RESET : ERRCLEAR : EXIT FUNCTION
'     END IF
'     GET$ #1, LOF(1), sTemp
'  CLOSE #1

  IF LEN(sTemp) < 2 THEN EXIT FUNCTION

  REPLACE $TAB WITH SPACE$(4) IN sTemp   'ensure there are no TAB$

  IF RIGHT$(UCASE$(incFile), 12) = "WIN32API.INC" THEN
     isWin32API = 1
  ELSEIF RIGHT$(UCASE$(incFile), 12) = "RICHEDIT.INC" THEN
     isRichEdit = 1
  END IF

'--------------------------------------------------------------------
'  LOCAL wordFlag AS LONG, WordNum AS LONG, acByte AS LONG, sBuf AS STRING
'  LOCAL inDQ AS LONG, isREM AS LONG, isWrapped AS LONG
'  LOCAL prevChar AS BYTE PTR

'  p = 1 : Letter = STRPTR(sTemp)
'  FOR ci = 1 TO LEN(sTemp)
'     SELECT CASE @Letter
'        CASE 97 TO 122, 65 TO 90, 36, 37, 48 TO 57, 95, 192 TO 214, 216 TO 246, 248 TO 255
'           IF isWrapped = 0 AND inDQ = 0 AND isREM = 0 AND wordFlag = 0 AND @Letter <> 95 THEN 'if valid char and no flag, word starts here (not with underscore)
'              wordFlag = 1 : pos = ci              'set wordflag and store position
'           END IF

'        CASE ELSE                       'we hit something else, like space, dot, etc..
'           IF wordFlag = 1 THEN         'if flag, then a word is ready
'              pos = ci - pos            'calculate length
'              IF pos > 2 THEN
'                 sBuf = PEEK$(Letter - pos, pos) 'grab word
'                 LineStr2 = UCASE$(sBuf)
'                 pos2 = pos2 + pos 'length
'                 INCR QuotePos     'counter
'                 IF INSTR(UCASE$(incFile), "WIN32API.INC") AND QuotePos2 < 10 THEN MSGBOX "x" + LineStr2 + "x"

'                 SELECT CASE ASC(LineStr2)
'                    CASE 35 '#

'                    CASE 36 '$
''                       IF LineStr2 = "$IF" THEN INCR QuotePos2

'                    CASE 37 '%

'                    CASE 69
''                       IF LineStr2 = "DECLARE" THEN INCR QuotePos2
'                 END SELECT
'                    
'                 INCR WordNum
'              END IF
'              wordFlag = 0              'and reset wordflag
'           END IF

'           SELECT CASE @Letter
'              CASE 13
'                 WordNum = 0 : inDQ = 0 : isREM = 0 : isWrapped = 0

'              CASE 34 'doublequote "
'                 IF isWrapped = 0 AND isREM = 0 THEN
'                    IF inDQ = 0 THEN inDQ = 1 ELSE inDQ = 0
'                 END IF

''              CASE 95 'underscore _
''                 nextChar = PEEK(Letter + 1)
''                 IF @nextChar = 32 AND isREM = 0 AND inDQ = 0 THEN
''                    isWrapped = 1
''                 END IF

'              CASE 39 'rem '
'                 IF inDQ = 0 AND isREM = 0 THEN isREM = 1

'           END SELECT

'     END SELECT
'     prevChar = Letter
'     INCR Letter
'  NEXT ci

'MSGBOX STR$(QuotePos) + " words with length " + STR$(pos2) + STR$(QuotePos2)
'--------------------------------------------------------------------

  p = 1 : Letter = STRPTR(sTemp)
  FOR ci = 1 TO LEN(sTemp)
     SELECT CASE @Letter
     CASE 13
        INCR gIncLine
'        IF gIncLine MOD 400 = 0 THEN NewEvents
        p = ci - p

        IF p > 3 AND PEEK(Letter - p) <> 39  THEN  'if more just than an empty line feed
           LineStr = PEEK$(Letter - p, p)    'this is a line

           tAsc = ASC(LineStr)
           IF tAsc <> 32 THEN
              LineStr2 = LineStr
           ELSE
              LineStr2 = LTRIM$(LineStr)
              tAsc = ASC(LineStr2)
           END IF
'           IF tAsc = 39 THEN 'if whole line is uncommented
'              INCR Letter : INCR ci : p = ci + 1 'jump past LF, store pos and get next line
'              EXIT SELECT
'           END IF

           '--------------------------------------------------------------------
           ' blank out text within double quotes
           '--------------------------------------------------------------------
           QuotePos = INSTR(LineStr2, $DQ)                   'see if there is any
           IF QuotePos THEN
              DO                                             'loop while there is any left
                 QuotePos2 = INSTR(QuotePos + 1, LineStr2, $DQ) 'look for matching pair
                 IF QuotePos2 THEN
                    MID$(LineStr2, QuotePos, QuotePos2 - QuotePos + 1) = SPACE$(QuotePos2 - QuotePos + 1)
                    QuotePos = INSTR(QuotePos2 + 1, LineStr2, $DQ)
                    IF QuotePos = 0 THEN EXIT DO
                 ELSE
                    EXIT DO
                 END IF
              LOOP
           END IF

           LineStr2 = UCASE$(EXTRACT$(LineStr2, "'"))              'cut off ev. uncommented part
           IF tAsc = 82 AND LEFT$(LineStr2, 4) = "REM " THEN       'if whole line in uncommented
              INCR Letter : INCR ci : p = ci + 1 : EXIT SELECT     'jump past LF, store pos and get next line
           ELSEIF INSTR(LineStr2, " REM ") THEN
              LineStr2 = LEFT$(LineStr2, INSTR(LineStr2, " REM ")) 'same here, if REM was used
           END IF
           IF ASC(LineStr2, -1) = 32 THEN LineStr2 = RTRIM$(LineStr2) 'trim off ev. trailing spaces

           '-------------------------------------------------------------------
           IF equWrapFlag = 1 THEN  'EQUATES - CONTINUED
              IF ASC(LineStr2, -1) = 95 THEN  ' _
                 equFull(cEqu-1) = equFull(cEqu-1) + SPACE$(51) + LTRIM$(LineStr) + $CRLF
              ELSE
                 equFull(cEqu-1) = equFull(cEqu-1) + SPACE$(51) + LTRIM$(LineStr)
                 equWrapFlag = 0
              END IF

           ELSEIF StructFlag = 1 THEN  'TYPE DECLARED STRUCTURES - FULL (CONTINUED)
              IF tAsc = 69 AND (LEFT$(LineStr2, 8) = "END TYPE" OR LEFT$(LineStr2, 9) = "END UNION") THEN
                 StructFlag = 0
                 structFull(cStruct-1) = structFull(cStruct-1) + LTRIM$(LineStr) + $CRLF
              ELSE
                 structFull(cStruct-1) = structFull(cStruct-1) + LineStr + $CRLF
              END IF

           ELSEIF FuncFlag = 1 THEN   'DECLARED FUNCTIONS - FULL (CONTINUED)
              IF ASC(LineStr2, -1) = 95 THEN
                 funcFull(cFunc-1) = funcFull(cFunc-1) + LineStr + $CRLF
              ELSE
                 funcFull(cFunc-1) = funcFull(cFunc-1) + LineStr
                 FuncFlag = 0
              END IF

           ELSEIF SubFlag = 1 THEN    'DECLARED SUBS - FULL (CONTINUED)
              IF ASC(LineStr2, -1) = 95 THEN
                 subFull(cSub-1) = subFull(cSub-1) + LineStr + $CRLF
              ELSE
                 subFull(cSub-1) = subFull(cSub-1) + LineStr
                 SubFlag = 0
              END IF

           ELSEIF iFuncFlag = 1 THEN  'FUNCTIONS - FULL (CONTINUED)
              IF tAsc = 69 AND LEFT$(LineStr2, 12) = "END FUNCTION" THEN
                 ifuncFull(cFunc2-1) = ifuncFull(cFunc2-1) + LineStr2 + $CRLF
                 iFuncFlag = 0
              ELSE
                 ifuncFull(cFunc2-1) = ifuncFull(cFunc2-1) + LineStr + $CRLF
              END IF

           ELSEIF iSubFlag = 1 THEN   'SUBS - FULL (CONTINUED)
              IF tAsc = 69 AND LEFT$(LineStr2, 7) = "END SUB" THEN
                 isubFull(cSub2-1) = isubFull(cSub2-1) + LineStr2 + $CRLF
                 iSubFlag = 0
              ELSE
                 isubFull(cSub2-1) = isubFull(cSub2-1) + LineStr + $CRLF
              END IF

           ELSEIF SkipFlag2 AND tAsc = 35 THEN
              IF ASC(LineStr2, 2) = 69 THEN
                 IF LEFT$(LineStr2, 5) = "#ELSE" OR _
                    LEFT$(LineStr2, 6) = "#ENDIF" THEN skipFlag2 = 0
              END IF

           '-------------------------------------------------------------------
           ELSEIF tAsc = 35 THEN
              IF isRichEdit THEN
                 IF skipFlag2 = 0 AND ASC(LineStr2, 2) = 73 THEN
                    IF LEFT$(LineStr2, 12) = "#IF NOT %DEF" THEN skipFlag2 = 1
                 END IF
              ELSEIF isWin32API THEN
                 IF skipFlag = 0  AND ASC(LineStr2, 2) = 73 THEN
                    IF LEFT$(LineStr2, 21) = "#IF %DEF(%NOBYVALPTR)" THEN skipFlag = 2
                 ELSEIF skipFlag = 2 AND ASC(LineStr2, 2) = 69 THEN
                    IF LEFT$(LineStr2, 5) = "#ELSE" THEN skipFlag = 1
                 ELSEIF skipFlag = 1 AND ASC(LineStr2, 2) = 69 THEN
                    IF LEFT$(LineStr2, 6) = "#ENDIF" THEN skipFlag = 0
                 END IF
              END IF

           ELSEIF tAsc = 37 OR tAsc = 36 THEN           '%EQUATES, 37=%, 36=$
              IF tAsc = 36 AND (ASC(LineStr2, 2) = 69 OR ASC(LineStr2, 2) = 73) THEN
'                 IF skipFlag AND LineStr2 = "$ELSEIF %DEF(%CCWIN)" THEN
'                    skipFlag = 0       'SKIP A FEW %PB_CC32 - DOUBLED FUNCTIONS

'                 IF LEFT$(LineStr2, 4) = "$IF " OR LEFT$(LineStr2, 8) = "$ELSEIF " OR _
'                    LEFT$(LineStr2, 6) = "$ENDIF" THEN skipFlag = 1
                 IF INSTR(LineStr2, "$IF ") OR INSTR(LineStr2, "$ELSEIF ") THEN
                    skipFlag = 1
                 END IF
              END IF


              IF skipFlag <> 1 AND skipFlag2 = 0 THEN
                 IF tAsc = 36 AND (ASC(LineStr2, 2) = 69 OR ASC(LineStr2, 2) = 73) AND _
                       (INSTR(LineStr2, "$ENDIF") OR INSTR(LineStr2, "$INCLUDE")) THEN
                    skipFlag = 0
                 ELSE
                    IF cEqu MOD 500 = 0 THEN
                       REDIM PRESERVE equName(cEqu + 500)
                       REDIM PRESERVE equFull(cEqu + 500)
                    END IF
                    pos = INSTR(LineStr2, "=")                  'look for =
                    equName(cEqu) = RTRIM$(LEFT$(LineStr2, pos - 1)) + CHR$(0) 'get equate's name

                    IF ASC(LineStr) = 32 THEN LineStr = LTRIM$(LineStr)
                    pos2 = INSTR(LineStr, "=")                  'look for =
                    IF ASC(LineStr2, -1) = 95 THEN
                       equWrapFlag = 1
                       equFull(cEqu) = USING$("#######", gIncLine) + " " + LEFT$(LineStr, pos2-1) + _ 'align value
                                       SPACE$(MAX&(1, 50 - LEN(LEFT$(LineStr, pos2))-1)) + _
                                       MID$(LineStr, pos2) + $CRLF
                    ELSE
                       equFull(cEqu) = USING$("#######", gIncLine) + " " + LEFT$(LineStr, pos2-1) + _ 'align value
                                       SPACE$(MAX&(1, 50 - LEN(LEFT$(LineStr, pos2))-1)) + _
                                       MID$(LineStr, pos2)
                    END IF
                    INCR cEqu
                 END IF
              ELSE
                 skipFlag = 0
              END IF

           ELSEIF (tAsc = 84 AND LEFT$(LineStr2, 5) = "TYPE ") OR _
                  (tAsc = 85 AND LEFT$(LineStr2, 6) = "UNION ") THEN 'TYPE DECLARED STRUCTURES (START)
              IF StructFlag = 0 AND SkipFlag <> 1 AND skipFlag2 = 0 THEN
                 IF cStruct MOD 200 = 0 THEN
                    REDIM PRESERVE structName(cStruct + 200)
                    REDIM PRESERVE structFull(cStruct + 200)
                 END IF
                 StructFlag = 1
                 IF ASC(LineStr) = 32 THEN LineStr = LTRIM$(LineStr)
                 IF LEFT$(LineStr2, 5) = "TYPE " THEN
                    LineStr2 = LTRIM$(MID$(LineStr2, 6))
                    pos = INSTR(LineStr2, " ")
                    IF pos THEN
                       structName(cStruct) = LEFT$(LineStr2, pos-1) + CHR$(0)
                    ELSE
                       structName(cStruct) = LineStr2 + CHR$(0)
                    END IF
                    structFull(cStruct) = USING$("#######", gIncLine) + " " + LineStr + $CRLF
                 ELSE
                    LineStr2 = LTRIM$(MID$(LineStr2, 6))
                    pos = INSTR(LineStr2, " ")
                    IF pos THEN
                       structName(cStruct) = LEFT$(LineStr2, pos-1) + CHR$(0)
                    ELSE
                       structName(cStruct) = LineStr2 + CHR$(0)
                    END IF
                    structFull(cStruct) = USING$("#######", gIncLine) + " " + LineStr + $CRLF
                 END IF
                 INCR cStruct
              END IF

           ELSEIF tAsc = 68 AND LEFT$(LineStr2, 16) = "DECLARE FUNCTION" AND SkipFlag <> 1 THEN 'DECLARED FUNCTIONS (START)
              IF cFunc MOD 200 = 0 THEN
                 REDIM PRESERVE funcName(cFunc + 200)
                 REDIM PRESERVE funcFull(cFunc + 200)
              END IF
              pos = INSTR(LineStr2, " LIB ")
              pos2 = INSTR(LineStr2, " CDECL ")
              IF pos2 THEN pos = MIN&(pos, pos2)
              funcName(cFunc) = TRIM$(MID$(LineStr2, 18, pos - 18)) + CHR$(0)
              IF ASC(LineStr2, -1) = 95 THEN
                 FuncFlag = 1
                 IF ASC(LineStr) <> 32 THEN
                    funcFull(cFunc) = LineStr + $CRLF
                 ELSE
                    funcFull(cFunc) = LTRIM$(LineStr) + $CRLF
                 END IF
              ELSE
                 IF ASC(LineStr) <> 32 THEN
                    funcFull(cFunc) = LineStr
                 ELSE
                    funcFull(cFunc) = LTRIM$(LineStr)
                 END IF
              END IF
              INCR cFunc

           ELSEIF tAsc = 68 AND LEFT$(LineStr2, 11) = "DECLARE SUB" THEN 'DECLARED SUBS (START)
              REPLACE "      " WITH " " IN LineStr 'adjust extra space embedded in some declared subs
              pos = INSTR(LineStr2, " LIB ")
              IF cSub MOD 200 = 0 THEN
                 REDIM PRESERVE subName(cSub + 200)
                 REDIM PRESERVE subFull(cSub + 200)
              END IF
              subName(cSub) = TRIM$(MID$(LineStr2, 13, pos - 13)) + CHR$(0)
              IF ASC(LineStr2, -1) = 95 THEN
                 SubFlag = 1
                 subFull(cSub) = LineStr + $CRLF
              ELSE
                 subFull(cSub) = LineStr
              END IF
              INCR cSub

           ELSEIF tAsc = 70 AND LEFT$(LineStr2, 9) = "FUNCTION " THEN 'FUNCTIONS (START)
              IF cFunc2 MOD 200 = 0 THEN
                 REDIM PRESERVE ifuncName(cFunc2 + 200)
                 REDIM PRESERVE ifuncFull(cFunc2 + 200)
              END IF
              LineStr2 = LTRIM$(MID$(LineStr2, 9))
              pos = INSTR(LineStr2, ANY " (")
              IF pos THEN
                 ifuncName(cFunc2) = LEFT$(LineStr2, pos - 1) + CHR$(0)
              ELSE
                 ifuncName(cFunc2) = LineStr2 + CHR$(0)
              END IF
              ifuncFull(cFunc2) = USING$("#######", gIncLine) + " " + LTRIM$(LineStr) + $CRLF
              iFuncFlag = 1
              INCR cFunc2

           ELSEIF tAsc = 83 AND LEFT$(LineStr2, 4) = "SUB " THEN 'SUBS (START)
              IF cSub2 MOD 200 = 0 THEN
                 REDIM PRESERVE isubName(cSub2 + 200)
                 REDIM PRESERVE isubFull(cSub2 + 200)
              END IF
              LineStr2 = LTRIM$(MID$(LineStr2, 4))
              pos = INSTR(LineStr2, ANY " (")
              IF pos THEN
                 isubName(cSub2) = LEFT$(LineStr2, pos - 1) + CHR$(0)
              ELSE
                 isubName(cSub2) = LineStr2 + CHR$(0)
              END IF
              isubFull(cSub2) = USING$("#######", gIncLine) + " " + LTRIM$(LineStr) + $CRLF
              iSubFlag = 1
              INCR cSub2

           END IF
        END IF

        INCR Letter : INCR ci : p = ci + 1   'jump past LF and store position
     END SELECT
     INCR Letter
  NEXT ci

  IF whatRun = lastRun THEN
     REDIM PRESERVE equName(cEqu -1)       'original name
     REDIM PRESERVE equFull(cEqu -1)       'complete, original line
     REDIM PRESERVE structName(cStruct -1) 'UCASE name, for search/compare
     REDIM PRESERVE structFull(cStruct -1) 'complete, original structure
     REDIM PRESERVE funcName(cFunc -1)
     REDIM PRESERVE funcFull(cFunc -1)     'complete, original function declare
     REDIM PRESERVE subName(cSub -1)
     REDIM PRESERVE subFull(cSub -1)       'complete, original sub declare
     REDIM PRESERVE ifuncName(cFunc2 -1)
     REDIM PRESERVE ifuncFull(cFunc2 -1)   'complete, original function
     REDIM PRESERVE isubName(cSub2 -1)
     REDIM PRESERVE isubFull(cSub2 -1)     'complete, original sub

     '---------------------------------------------------------------------
     IndexEquates2 equName(), equFull(), equStart(), equCount()
     IndexArray2 structName(), structFull(), StructStart(), StructCount(), 1
     IndexArray2 funcName(), funcFull(), FuncStart(), FuncCount(), 1
     IndexArray subName(), subFull(), SubStart(), SubCount()
     IndexArray2 ifuncName(), ifuncFull(), iFuncStart(), iFuncCount(), 1
     IndexArray isubName(), isubFull(), iSubStart(), iSubCount()
     '---------------------------------------------------------------------
  END IF

'  IF whatRun = lastRun THEN
'     ARRAY SORT equFull()
'     ARRAY SORT structFull()
'     ARRAY SORT funcName(), TAGARRAY funcFull()
'     ARRAY SORT subName(), TAGARRAY subFull()
'     ARRAY SORT ifuncFull() ', TAGARRAY ifuncName()
'     ARRAY SORT isubFull()

'     OPEN "c:\pb\inclean2.txt" FOR OUTPUT AS #1 LEN = 16383
'     IF ERR THEN
'        FUNCTION = -1
'        RESET : ERRCLEAR : EXIT FUNCTION
'     END IF
'     'PRINT #1, "' " + STR$(tTot) + STR$(cEqu) + STR$(cStruct) + STR$(cFunc) + STR$(cSub)
'     tTot = TIMER

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Equates: " + STR$(cEqu)
'     'PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cEqu -1
''        PRINT #1, equName(ci)
''        PRINT #1, equFull(ci)
'        PRINT #1, CHR$(192) + MID$(equFull(ci), 9)
'     NEXT
'     'PRINT #1,""

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Structures: " + STR$(cStruct)
'     'PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cStruct -1
'        'PRINT #1, structName(ci)
'        PRINT #1, CHR$(193) + MID$(structFull(ci), 9) 'structFull(ci)
'     NEXT

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Declared Functions: " + STR$(cFunc)
'     'PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cFunc -1
'        'PRINT #1,funcName(ci)
'        PRINT #1, CHR$(194) + funcFull(ci)
'     NEXT
'     'PRINT #1,""

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Declared Subs: " + STR$(cSub)
'     'PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cSub -1
'        'PRINT #1,subName(ci)
'        PRINT #1, CHR$(195) + subFull(ci)
'     NEXT
'     'PRINT #1,""

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Functions: " + STR$(cFunc2)
'     'PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cFunc2 -1
'        'PRINT #1,ifuncName(ci)
'        PRINT #1, CHR$(196) + MID$(ifuncFull(ci), 9) 'ifuncFull(ci)
'     NEXT
'     'PRINT #1,""

'     'PRINT #1,"'-----------------------------------------------------------"
'     'PRINT #1,"' Sub: " + STR$(cSub2)
''     PRINT #1,"'-----------------------------------------------------------"
'     FOR ci = 0 TO cSub2 -1
'        'PRINT #1, isubName(ci)
'        PRINT #1, CHR$(197) + MID$(isubFull(ci), 9) 'isubFull(ci)
'     NEXT
'     'PRINT #1,"'-----------------------------------------------------------"
'     CLOSE #1
'  END IF

  'tTot = TIMER - tTot
  'MSGBOX STR$(tTot) + STR$(cEqu) + STR$(cStruct) + STR$(cFunc) + STR$(cSub)
  'BEEP
'  MOUSEPTR 1
'  FUNCTION = 1

'  SLEEP 20
'  ShellExecute 0, "open", "c:\pb\inclean.txt", BYVAL 0, BYVAL 0, %SW_SHOWNORMAL
  FUNCTION = 1
END FUNCTION

'
' Resolve include path from Registry (PB) or command line into array
'
SUB ResolveIncPath(BYVAL tmpIncDir AS STRING)
  LOCAL ii AS LONG, h AS LONG, iCnt AS LONG, isOverride AS LONG, tmpStr AS STRING

  IF LEN(tmpIncDir) THEN                                 'if we got anything
     REPLACE $DQ WITH "" IN tmpIncDir                    'in case of couble-quoted LFN's
     IF LEFT$(tmpIncDir, 2) = ".\" THEN
        tmpIncDir = TRIM$(MID$(tmpIncDir, 3))            'if to use CURDIR as primary path
        isOverride = 1
     END IF
     IF LEFT$(tmpIncDir, 1) = ";" THEN tmpIncDir = TRIM$(MID$(tmpIncDir, 2)) 'should be, but who knows, so..

     IF INSTR(tmpIncDir, ";") THEN                       'if it contains multiple paths
        FOR ii = 1 TO PARSECOUNT(tmpIncDir, ";")         'loop through string
           tmpStr = TRIM$(PARSE$(tmpIncDir, ";", ii))    'parse out each path
           IF ASC(tmpStr, -1) <> 92 THEN tmpStr = tmpStr + "\" 'make sure it has trailing backslash
           IF LEFT$(tmpStr, 1) = "\" THEN tmpStr = LEFT$(CURDIR$, 2) + tmpStr 'if \xx

           IF LEN(tmpStr) AND doFileExist(tmpStr) THEN  'if we got a path and it exists
              ARRAY SCAN sIncDir(), COLLATE UCASE, = tmpStr, TO h 'look for duplicates in existing array
              IF h = 0 THEN
                 iCnt = UBOUND(sIncDir) + 1
                 REDIM PRESERVE sIncDir(iCnt)               'prepare array
                 IF isOverride THEN
                    ARRAY INSERT sIncDir(0), tmpStr
                 ELSE
                    sIncDir(iCnt) = tmpStr
                 END IF
                 INCR iCnt                                  'increase temporary array counter
              END IF
           END IF
        NEXT

     ELSE                                                'else, single path was given
        IF ASC(tmpIncDir, -1) <> 92 THEN tmpIncDir = tmpIncDir + "\" 'make sure it has trailing backslash
        IF LEFT$(tmpIncDir, 1) = "\" THEN tmpIncDir = LEFT$(CURDIR$, 2) + tmpIncDir 'if \xx
        IF LEN(tmpIncDir) AND doFileExist(tmpIncDir) THEN                  'if it exists
           ARRAY SCAN sIncDir(), COLLATE UCASE, = tmpIncDir, TO h 'look for duplicates in existing array
           IF h = 0 THEN
              iCnt = UBOUND(sIncDir) + 1
              REDIM PRESERVE sIncDir(iCnt)               'prepare array
              IF isOverride THEN
                 ARRAY INSERT sIncDir(0), tmpIncDir
              ELSE
                 sIncDir(iCnt) = tmpIncDir
              END IF
           END IF
        END IF
     END IF
  END IF

'  FOR ii = 0 TO UBOUND(sIncDir)
'     MSGBOX sIncDir(ii) + STR$(ii)
'  NEXT
END SUB

'
' Resolve eventual relative path
'
FUNCTION ResolveRelativePath(BYVAL BasePathStr AS STRING, BYVAL sWork AS STRING) AS STRING
  LOCAL sTemp2 AS STRING
  
  IF INSTR(sWork, "/") THEN REPLACE "/" WITH "\" IN sWork 'so ResolveRelativePath will work

  IF LEFT$(sWork, 1) = "\" THEN
     FUNCTION = LEFT$(BasePathStr, 2) + sWork 'if \xx
  ELSEIF LEFT$(sWork, 2) = ".\" THEN  'resolve eventual relative paths
     FUNCTION = BasePathStr + MID$(sWork, 2)
  ELSEIF LEFT$(sWork, 3) = "..\" THEN
     FUNCTION = LEFT$(BasePathStr, INSTR(-2, BasePathStr, "\")) + MID$(sWork, 4)
  ELSEIF LEFT$(sWork, 4) = "...\" THEN
     sTemp2 = LEFT$(BasePathStr, INSTR(-2, BasePathStr, "\"))
     FUNCTION = LEFT$(sTemp2, INSTR(-2, sTemp2, "\")) + MID$(sWork, 5)
  ELSEIF LEFT$(sWork, 5) = "....\" THEN
     sTemp2 = LEFT$(BasePathStr, INSTR(-2, BasePathStr, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     FUNCTION = LEFT$(sTemp2, INSTR(-2, sTemp2, "\")) + MID$(sWork, 6)
  ELSEIF LEFT$(sWork, 6) = ".....\" THEN
     sTemp2 = LEFT$(BasePathStr, INSTR(-2, BasePathStr, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     FUNCTION = LEFT$(sTemp2, INSTR(-2, sTemp2, "\")) + MID$(sWork, 7)
  ELSEIF LEFT$(sWork, 7) = "......\" THEN
     sTemp2 = LEFT$(BasePathStr, INSTR(-2, BasePathStr, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     sTemp2 = LEFT$(sTemp2, INSTR(-2, sTemp2, "\"))
     FUNCTION = LEFT$(sTemp2, INSTR(-2, sTemp2, "\")) + MID$(sWork, 8)
  ELSE
     FUNCTION = sWork
  END IF

END FUNCTION
